!! H-bonding class for all AA atoms
MODULE names
  implicit none
  private
  character(len=4),dimension(20,14) :: attype
  integer,dimension(20,14) :: hbtype
  character(len=20) :: res1="ACDEFGHIKLMNPQRSTVWY"
  character(len=80) :: res3="ALA CYS ASP GLU PHE GLY HIS ILE LYS LEU MET ASN PRO GLN ARG SER THR VAL TRP TYR"
  logical :: inited=.false.
  !!-------
  public ::  names_init, names_gethtype
CONTAINS
  !!-------------------------------------------------------------------------------------------------------
  subroutine names_init()
  inited = .true.
  attype = " "
  hbtype = -1
  !! ALA
  attype(1,1:5) = (/' C  ',' CA ',' CB ',' N  ',' O  '/)
  hbtype(1,1:5) = (/0,0,0,2,1/)
  !! CYS
  attype(2,1:6) = (/' C  ',' CA ',' CB ',' N  ',' O  ',' SG '/)
  hbtype(2,1:6) = (/0,0,0,2,1,3/)
  !! ASP
  attype(3,1:8) = (/' C  ',' CA ',' CB ',' CG ',' N  ',' O  ',' OD1',' OD2'/)
  hbtype(3,1:8) = (/0,0,0,0,2,1,1,1/)
  !! GLU
  attype(4,1:9) = (/' C  ',' CA ',' CB ',' CD ',' CG ',' N  ',' O  ',' OE1',' OE2'/)
  hbtype(4,1:9) = (/0,0,0,0,0,2,1,1,1/)
  !! PHE
  attype(5,1:11) = (/' C  ',' CA ',' CB ',' CD1',' CD2',' CE1',' CE2',' CG ',' CZ ',' N  ',' O  '/)
  hbtype(5,1:11) = (/0,0,0,0,0,0,0,0,0,2,1/)
  !! GLY
  attype(6,1:4) = (/' C  ',' CA ',' N  ',' O  '/)
  hbtype(6,1:4) = (/0,0,2,1/)
  !! HIS
  attype(7,1:10) = (/' C  ',' CA ',' CB ',' CD2',' CE1',' CG ',' N  ',' ND1',' NE2',' O  '/)
  hbtype(7,1:10) = (/0,0,0,0,0,0,2,3,3,1/)
  !! ILE
  attype(8,1:8) = (/' C  ',' CA ',' CB ',' CD1',' CG1',' CG2',' N  ',' O  '/)
  hbtype(8,1:8) = (/0,0,0,0,0,0,2,1/)
  !! LYS
  attype(9,1:9) = (/' C  ',' CA ',' CB ',' CD ',' CE ',' CG ',' N  ',' NZ ',' O  '/)
  hbtype(9,1:9) = (/0,0,0,0,0,0,2,2,1/)
  !! LEU
  attype(10,1:8) = (/' C  ',' CA ',' CB ',' CD1',' CD2',' CG ',' N  ',' O  '/)
  hbtype(10,1:8) = (/0,0,0,0,0,0,2,1/)
  !! MET
  attype(11,1:8) = (/' C  ',' CA ',' CB ',' CE ',' CG ',' N  ',' O  ',' SD '/)
  hbtype(11,1:8) = (/0,0,0,0,0,2,1,0/)
  !! ASN
  attype(12,1:8) = (/' C  ',' CA ',' CB ',' CG ',' N  ',' ND2',' O  ',' OD1'/)
  hbtype(12,1:8) = (/0,0,0,0,2,2,1,1/)
  !! PRO
  attype(13,1:7) = (/' C  ',' CA ',' CB ',' CD ',' CG ',' N  ',' O  '/)
  hbtype(13,1:7) = (/0,0,0,0,0,2,1/)
  !! GLN
  attype(14,1:9) = (/' C  ',' CA ',' CB ',' CD ',' CG ',' N  ',' NE2',' O  ',' OE1'/)
  hbtype(14,1:9) = (/0,0,0,0,0,2,2,1,1/)
  !! ARG
  attype(15,1:11) = (/' C  ',' CA ',' CB ',' CD ',' CG ',' CZ ',' N  ',' NE ',' NH1',' NH2',' O  '/)
  hbtype(15,1:11) = (/0,0,0,0,0,0,2,2,2,2,0/)
  !! SER
  attype(16,1:6) = (/' C  ',' CA ',' CB ',' N  ',' O  ',' OG '/)
  hbtype(16,1:6) = (/0,0,0,2,1,3/)
  !! THR
  attype(17,1:7) = (/' C  ',' CA ',' CB ',' CG2',' N  ',' O  ',' OG1'/)
  hbtype(17,1:7) = (/0,0,0,0,2,1,3/)
  !! VAL
  attype(18,1:7) = (/' C  ',' CA ',' CB ',' CG1',' CG2',' N  ',' O  '/)
  hbtype(18,1:7) = (/0,0,0,0,0,2,1/)
  !! TRP
  attype(19,1:14) = (/' C  ',' CA ',' CB ',' CD1',' CD2',' CE2',' CE3',' CG ',' CH2',' CZ2',' CZ3',' N  ',' NE1',' O  '/)
  hbtype(19,1:14) = (/0,0,0,0,0,0,0,0,0,0,0,2,2,1/)
  !! TYR
  attype(20,1:12) = (/' C  ',' CA ',' CB ',' CD1',' CD2',' CE1',' CE2',' CG ',' CZ ',' N  ',' O  ',' OH '/)
  hbtype(20,1:12) = (/0,0,0,0,0,0,0,0,0,2,1,3/)
  end subroutine names_init
  !!-------------------------------------------------------------------------------------------------------
  subroutine names_gethtype(resname,atomname,htype) !! use aline(13:16) and aline(
    character(len=*),intent(in) :: resname, atomname
    integer,intent(out) :: htype
    integer :: i,j
    if (.not.inited) call names_init()
    i = index(res3,resname)/4 + 1
    do j=1,14
      if (atomname==attype(i,j)) exit
    enddo
    if (j>14) then
      !! optional
      ! write(0,*) "Unknown atom type, ignored: ",trim(resname), trim(atomname)
      htype = -1
      !! stop 'anchor.f90:: error getting atom type'
    else
      htype = hbtype(i,j)
    endif
  end subroutine names_gethtype
  !!-------------------------------------------------------------------------------------------------------
end MODULE names
