program readbdc
  use bdc
  implicit none
  integer,parameter :: RECSIZE=5*4*3+4
  integer :: resid
  character(len=1000) :: binfile
  real,dimension(3,5) :: fiveatom
  real,dimension(:,:),pointer :: segment
  integer :: jarg, iargc, irec, ios=0, slen, srec, i
  jarg = iargc()
  if (jarg < 1) then
    write(*,*) 'Usage: xreadbdc binaryfile'
    stop
  endif
  call getarg(1,binfile)
  call bdc_init(binfile)
  !! open(11,file=trim(binfile),status='old',form='unformatted',access='direct',recl=RECSIZE,iostat=ios)
  !! if (ios/=0) stop 'Error opening binary file'
  irec = 1
  do
    ! irec = irec + 1
    ! read(11,rec=irec,iostat=ios) resid,fiveatom
    ! if (ios/=0) exit
    slen = 0
    call bdc_getnextsegment(irec=irec,segment=segment,slen=slen,srec=srec)
    if (irec==1) exit
    write(*,'("Segment starting at ",i9," length=",i9)') srec,slen
    cycle
    if (slen < 2) then
      write(*,'("REJECT")')
      cycle
    endif
    do i=1,slen
      write(*,'("+",i4,15f7.2)') i-1,segment(1:3,(i-1)*5+1:(i-1)*5+5)
    enddo
  enddo
  call bdc_close(segment)
  !! close(11)
end program readbdc
